source: trunk/test/common_defs.sh.in @ 2806

Last change on this file since 2806 was 2806, checked in by Peter, 9 years ago

avoid spurious error on OSX Tiger on which 'rm foo/.*' tries to remove
'foo/.' and 'foo/..'.

  • Property svn:eol-style set to native
  • Property svn:keywords set to Id
File size: 4.3 KB
Line 
1# @configure_input@
2# $Id: common_defs.sh.in 2806 2012-08-02 08:43:02Z peter $
3
4# Copyright (C) 2009, 2010, 2011, 2012 Peter Johansson
5#
6# This file is part of the yat library, http://dev.thep.lu.se/yat
7#
8# The yat library is free software; you can redistribute it
9# and/or modify it under the terms of the GNU General Public License as
10# published by the Free Software Foundation; either version 3 of the
11# License, or (at your option) any later version.
12#
13# The yat library is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
16# General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with yat. If not, see <http://www.gnu.org/licenses/>.
20
21
22# bootstrap a test project
23#
24bootstrap ()
25{
26    rm -rf m4
27    @MKDIR_P@ m4
28    cp @abs_top_srcdir@/m4/*.m4 m4/.
29    rm -f m4/lt*.m4 m4/libtool.m4
30    autoreconf -siv && true
31    res=$?
32    case $res in
33        0)
34            :;;
35        63)
36            exit_skip;;
37        *)
38            exit $res;;
39    esac
40}
41
42# Usage: run PROG EXPECTED_EXITCODE [OPTION]...
43run ()
44{
45    test $# -ge 2 || exit_fatal
46    foo_prog=$1
47    shift
48    expected_exitcode=$1
49    shift
50    exitcode=0
51    $foo_prog ${1+"$@"} > stdout 2>stderr || exitcode=$?
52    cat stderr >&2
53    cat stdout
54    test $exitcode = $expected_exitcode || Exit 1
55}
56
57Exit () { set +x; exit $1; }
58warn_ () { echo $@ >&2; }
59exit_fail () { warn_ "$me: failed test: $@"; Exit 1; }
60exit_fatal () { warn_ "$me: hard error: $@"; Exit 99; }
61exit_skip () { warn_ "$me: skipped test: $@"; Exit 77; }
62exit_success () { echo "$me: successsful test: $@"; Exit 0; }
63
64me=$0
65
66echo "=== Running $me ==="
67
68# if required tool is not available, exit_skip
69if test -n "$required"; then
70  for tool in $required; do
71    case $tool in
72      automake)
73      echo "$me: running $tool --version"
74      ($tool --version) || exit_skip;
75      # skip test if automake older than v1.10
76      version_am=`$tool --version | head -n 1 | cut -f 2 -d ')'`
77      ver_major=`echo ${version_am} | cut -f 1 -d '.'`
78      test ${ver_major} -ge 1 || exit_skip
79      ver_minor=`echo ${version_am} | cut -f 2 -d '.'`
80      test ${ver_major} -gt 1 || test ${ver_minor} -ge 10 || exit_skip
81      ;;
82      doxygen)
83      test @have_doxygen@ = "yes" || exit_skip no doxygen
84      ;;
85      libtool)
86      # GNU libtool comes as glibtool on Mac OS
87      (echo "$me: running libtool --version" && libtool --version) || \
88      (echo "$me: running glibtool --version" && glibtool --version) || \
89       exit_skip
90      ;;
91      static)
92      if (test "x@enable_static@" = "xno"); then
93        echo static libyat disabled;
94        exit_skip;
95      fi
96      ;;
97      *)
98      echo "$me: running $tool --version"
99      ($tool --version) || exit_skip
100    esac
101  done
102fi
103
104# some defs we need in tests
105test_dir=`echo $me.dir | sed -e 's,.*[\\/],,'`
106test_dir="test/testSubDir/$test_dir"
107abs_top_builddir=@abs_top_builddir@
108abs_top_srcdir=@abs_top_srcdir@
109have_doxygen="@have_doxygen@"
110
111# user is always right
112test -z "$DOXYGEN" && DOXYGEN="@DOXYGEN@"
113
114rm -rf $test_dir/*
115@MKDIR_P@ --verbose $test_dir
116
117cd $test_dir
118
119if (echo "$required" | grep autoconf > /dev/null); then
120echo "creating configure.ac"
121cat > configure.ac <<EOF
122AC_INIT([hello],[1.0])
123AC_CONFIG_SRCDIR([hello.cc])
124AC_CONFIG_MACRO_DIR([m4])
125EOF
126if (echo "$required" | grep automake > /dev/null); then
127echo "AM_INIT_AUTOMAKE([foreign])" >> configure.ac
128fi
129if (echo "$required" | grep libtool > /dev/null); then
130cat >> configure.ac << EOF
131AC_LANG([C++])
132AC_PROG_CXXCPP
133AC_PROG_CXX
134AC_PROG_LIBTOOL
135EOF
136fi
137
138
139echo "creating Makefile.am"
140cat > Makefile.am <<EOF
141ACLOCAL_AMFLAGS = -I m4
142AM_CPPFLAGS = \$(YAT_CPPFLAGS)
143AM_CXXFLAGS = \$(YAT_CXXFLAGS)
144LDADD = \$(YAT_LDADD)
145bin_PROGRAMS = hello
146TESTS = hello
147hello_SOURCES = hello.cc
148EOF
149
150echo "creating hello.cc"
151cat > hello.cc <<EOF
152#include <yat/utility/Vector.h>
153#include <yat/utility/version.h>
154#include <algorithm>
155#include <iostream>
156#include <string>
157int main(void)
158{
159  using namespace theplu::yat;
160  if (utility::version()!="@VERSION@") {
161    std::cerr << "Incorrect version of linked libyat\n";
162    return 1;
163  }
164  // testing something with gsl
165  utility::Vector v(10);
166  v.resize(120); 
167  // testing something with boost
168  std::copy(v.begin(), v.begin()+10, v.begin()+10);
169  return 0;
170}
171EOF
172fi #end of creation of autotool files
173
174# turn on shell traces
175set -x
Note: See TracBrowser for help on using the repository browser.